openerp.barcode_sale_order = function (instance, local) {
    local.widgetInstance = null;
    local.parentInstance = null;

    local.SaleOrderSearchWidget = instance.Widget.extend({
        template : "barcode_sale_order.SaleOrderSearch",

        // events:{
        //     'click .activate_barcode' : 'showSearch',
        // },

        init:function(parent){
            this._super(parent);
            this.buttons = parent.$buttons;
        },

        updateId : function(id){
            var self = this;
            self.id=id;
        },

        reloadLine: function() {
            local.parentInstance.reload();
        },

        start: function () {
            var self = this;
            this.$el.click(function () {
                self.fecthInitial();
            });
        },

        showMensaje: function(mensaje){
            var self = this;
            $("#dialog" ).dialog({
                autoOpen: true,
                resizable: false,
                modal: true,
                title: 'Atención',
                width: 500,
                open: function() {
                    $(this).html(mensaje);
                },
                show: {
                    effect: "fade",
                    duration: 200
                },
                hide: {
                    effect: "fade",
                    duration: 200
                },
                buttons: {
                    Aceptar: function() {
                        $(this).dialog('close');
                    }
                }
            });
            return
        },

        fecthInitial: function(){
            var id = openerp.webclient._current_state.id;
            var self = this;
            self.fecthSale(id).then(function(sale){
                return sale;
            }).then(function(sale){
                self.sale = sale;
                return self.fetchProductProduct();
            }).then(function(ProductProduct){
                self.ProductProduct = ProductProduct;
                self.inicializarBuscador();
            });
            return false;
        },

        fecthSale: function(id){
            var defer = $.Deferred();
            var fields=['id','name','partner_id','state'];
            var domain=[['id','=', id]];
            var Sale = new instance.web.Model('sale.order');
            Sale.query(fields).filter(domain).order_by('id').all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },

        fetchProductProduct: function () {
            var defer = $.Deferred();
            var fields=['id','name','attribute_str','default_code','ean13'];
            var domain=[['active','=', true],['sale_ok','=', true]];
            var ProductProduct = new instance.web.Model('product.product');
            ProductProduct.query(fields).filter(domain).order_by('id').all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },

        getProductProduct : function(id){
            var self = this;
            return _.filter(self.ProductProduct, function(item){
                return item.id == id;
            });
        },

        inicializarBuscador: function () {
            var self = this;
            var selectProduct;
            $("#productSearch").keypress(function(e) {
                id = openerp.webclient._current_state.id;
                if(id == undefined){
                    self.showMensaje('Debe guardar el documento antes de continuar.');
                    self.$el.find('#productSearch').val('');
                }
                var product = [];
                var ean13 = $('#productSearch').val();
                var code = (e.keyCode ? e.keyCode : e.which);
                if(code==13){
                    product = _.filter(self.ProductProduct,function (item) {
                        return item.ean13 == ean13;
                    })
                    if(product.length > 0){
                        self.factInsertProduct(product);
                    }else{
                        product = _.filter(self.ProductProduct,function (item) {
                            var dato = item.ean13;
                            if(dato){
                                dato = dato.substring(0,9);
                            }
                            return dato == ean13;
                        })
                        if(product.length > 0){
                            self.factInsertProduct(product);
                        }else{
                            self.showMensaje('Producto no encontrado.');
                        }
                    }
                }
            });
        },

        factInsertProduct:function(product){
            var self = this;
            var prod = product[0].id;
            var qty = 1;
            self.fetchInsert(prod, qty).then(function(results) {
                return results;
            }).then(function(){
                self.reloadLine();
            });
        },

        fetchInsert: function(product_id, qty) {
            var self = this;
            var defer = $.Deferred();
            var sale = new openerp.web.Model('sale.order');
            sale.call('sale_insert_lines_by_eiru_original',[
                {
                    id: self.sale[0].id,
                    product_id: product_id,
                }
            ], {
                    context: new openerp.web.CompoundContext()
            }).then(function(results) {
                defer.resolve(results);
            });
            self.$el.find('#productSearch').val('');
            return defer;
        },
    });

    if (instance.web && instance.web.FormView) {
        instance.web.FormView.include({
            load_form: function (record) {
                this._super.apply(this, arguments);
                if (this.model !== 'sale.order') return;
                local.parentInstance = this;
                if (local.widgetInstance) {
                    local.widgetInstance.updateId(record.id);
                }
                local.widgetInstance = new local.SaleOrderSearchWidget(this);
                var elemento = this.$el.find('.oe_form_sheet.oe_form_sheet_width');
                elemento =  elemento.find('.product_search_box');
                local.widgetInstance.appendTo(elemento);
                local.widgetInstance.updateId(record.id);
            }
        });
    }
}
